apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "deal.fullname" . }}
  labels:
    {{- include "deal.labels" . | nindent 4 }}
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "deal.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "deal.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "deal.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: {{ .Values.service.port }}
              protocol: TCP
          
          
          env:
            - name: APPLICATION_PORT
              value: {{ .Values.service.port | quote }}
            - name: CONVEYOR_APP_HOST
              value: {{ .Values.conveyor.url | quote }}
            - name: CONVEYOR_APP_PORT
              value: {{ .Values.conveyor.port | quote }}

            - name: DB_HOST
              value: {{ .Values.postgresql.url | quote}}
            - name: DB_PORT
              value: {{ .Values.postgresql.service.ports.postgresql | quote}}
            - name: DB_NAME
              value: {{ .Values.postgresql.auth.database | quote}}
            - name: DB_USERNAME
              value: {{ .Values.postgresql.auth.username | quote}}
            - name: DB_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.postgresql.url | quote}}
                  key: password
          
          
          livenessProbe:
            initialDelaySeconds: 100
            timeoutSeconds: 3
            periodSeconds: 3
            failureThreshold: 2
            httpGet:
              scheme: HTTP
              path: /actuator/health/liveness
              port: 8080
          readinessProbe:
            initialDelaySeconds: 50
            timeoutSeconds: 10
            failureThreshold: 3
            httpGet:
              scheme: HTTP
              path: /actuator/health/readiness/
              port: 8080
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
